var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  useReactSaga: () => useReactSaga
});
var import_react = __toModule(require("react"));
var import_redux_saga = __toModule(require("redux-saga"));
var import_effects = __toModule(require("redux-saga/effects"));
const STATE_READY = "@@STATE_READY";
const useReactSaga = ({ state, dispatch, saga }) => {
  const environment = import_react.default.useRef({
    state,
    channel: (0, import_redux_saga.stdChannel)(),
    actions: [],
    stateChangePossible: false
  });
  const [_, forceUpdate] = import_react.default.useState({});
  const put = import_react.default.useCallback((action) => {
    dispatch(action);
    environment.current.actions.push(action);
    forceUpdate({});
  }, []);
  import_react.default.useEffect(() => {
    const task = (0, import_redux_saga.runSaga)({
      getState: () => environment.current.state,
      dispatch: put,
      channel: environment.current.channel,
      effectMiddlewares: [
        (runEffect) => (effect) => {
          const stateChangePossible = environment.current.stateChangePossible;
          if (effect.type === import_effects.effectTypes.PUT) {
            environment.current.stateChangePossible = true;
          }
          if (effect.type === import_effects.effectTypes.SELECT && stateChangePossible) {
            environment.current.stateChangePossible = false;
            return runEffect((0, import_effects.call)(function* (selector, args) {
              const action = yield (0, import_effects.take)(STATE_READY);
              return yield (0, import_effects.call)(selector, action.payload, ...args);
            }, effect.payload.selector, effect.payload.args));
          }
          return runEffect(effect);
        }
      ]
    }, saga);
    return () => task.cancel();
  }, []);
  import_react.default.useEffect(() => {
    environment.current.state = state;
    if (environment.current.actions.length > 0) {
      const actions = environment.current.actions;
      environment.current.actions = [];
      actions.forEach((action) => environment.current.channel.put(action));
      environment.current.channel.put({
        type: STATE_READY,
        payload: state
      });
      environment.current.stateChangePossible = false;
    }
  });
  return put;
};
//# sourceMappingURL=index.js.map
